// Boot Camp - 14
// 1 - start with a basic file like War Factory and delete stuff - done
// 2 - then use the Mike stuff to carry the flag and set special Identity - done
// 3 - get scoreboard to work
// 4 - now get points for flag - yee haw did it
// 4b - problem: if $tm killed the flag stays with him when he comes back - fixed
// 4c - give 60 pts for killing flag carrier - need to test this
// 4d - go and set talky stuff - messagebox mission will start
// 5 - now set rules and guidelines
// 6 - fix pilots - do a cybrid warning messagebox ok - test - ok
// 7 - go into ME and
// 7a - make 4 cities
// 7b - set 4 random points for NavAlpha - see Beau Geste
// 7c - set up 12 droppoints around perimeter - test
// 7d - think about playersdead thingy
// ok when a brid dies, red flag surrendered and it is. dunno about this one.
// ok death messages are "unknown" - tested ok
// 8 - set alpha var = 20
// 9 - mission start in 30 - ok,  any kill drops flag - fixed ok,
// 10 - scoreboard carryover fixed  - ok
// 11 - make the AI not so bad?? go 1.0 to 0.7 - ok
// 12 - cut number of AI at start, have Alpha shift every 7 min - test - ok
// 13 - do end statements - done
// 14 - fix basement in ME - done


//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
$killPoints = 5;
$deathPoints = 2;
$flagValue = 100;
$carrierValue = 60;

$OVconvoyTech = 1;

$server::TeamDamage = true;

$actionStarted = false;

$maxRange = 2500;
$minRange = 500;

// how many player are alive at squad drop time
$numLivePlayers = 0;

//------------ADD AS A TEST---------------
function setDefaultMissionOptions()
{
//*************set for normal DM and test************
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = False;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = False;

   // what can the server admin choose for available teams
   $server::disableTeamRed = False;
   $server::disableTeamBlue = true;
   $server::disableTeamYellow = False;
   $server::disableTeamPurple = true;

}
//---------ADD AS A TEST-------------------
   
Pilot backupPilot
{
   id = 29;
   skill = 0.7;
   accuracy = 0.7;
   aggressiveness = 0.7;
   activateDist = 11000.0;
   deactivateBuff = 12000.0;
   targetFreq = 2.0;
   trackFreq = 0.1;
   fireFreq = 0.5;
   LOSFreq = 0.2;
   orderFreq = 4.0;   

};



function onMissionLoad()
{


   cdAudioCycle("Gnash", "Cloudburst", "Cyberntx"); 

    $textMsg = "Mission Credits:  Slade  \n"@
      "<F5>Objectives:   \n"@
         "Maximize your point score. \n"@
         "Get Flag at Bravo by scanning, deliver to Alpha = 100 points \n"@
         "Killing carrier = 60 points \n"@
         "Kill = 5 points, Team Kill = -5 points, Death = -2 points \n"@ 
         "Respawning is allowed. Any kill heals your vehicle and"@
         " reloads your weapons. Team Damage is ON.";

   %history = 
"\n\nDate: 2831. You have been volunteered for extended Boot Camp.  This is your \n"@
"final excercise.  We are dropping you into a deserted area.  Medics will heal your \n"@
"hercs when you lose a battle.  The excercise ends when the Battle Flag at Bravo  \n"@
"is delivered to Nav Alpha.  Those of you with 40 points or more will go on to  \n"@
"Special Operations.  Those of you with less than 40 points will clean latrines   \n"@
"for the Imperial Troopers.  Nobody is your buddy here.  If you have taken a dislike  \n"@
"to someone, this is your chance to bowb them.";


   setGameInfo ($textMsg @ %history);


}


//--------------------------------------------
function onMissionStart()
{
   newFormation( Delta, 0,0,0, -60,-60,0, 60,-45,0, 0,-120,0 ); 
   newFormation( Line,  0,0,0, 0,-40,0, 0,-80,0, 0,-120,0 );

   cdAudioCycle( Purge, Terror, gnash);

   iceSounds();
   init();

}

//--125-------------------------------------------
function player::onAdd(%this)                                                                                                                        
{
   player::onAddLog(%this);
say ( %this, 0, $Version @"\n"@ $textMsg );
say ( %this, 0,  "\nCheck the game info tab for more details, Mission will start 30 seconds after loading.");
 schedule ("messagebox (%player, \"TAC-COM:  There may be Brids in the area.\");",120);

}

//--------------------------------------------
function vehicle::onAdd(%this)                                                                                                                        
{


// see if it is a player, if not exit
   %player = playerManager::vehicleIdToPlayerNum(%this);

   if (%player == 0) 
      return;


                                                                                   
   if (getTeam (%this) != *IDSTR_TEAM_YELLOW)
    {
     setTeam(%this, *IDSTR_TEAM_YELLOW);

     redrop(%this);


    }


//---------------------------------------------
 if ( $actionStarted == true )
   {
    if ( %player.state == "tked" )  
        {
   	%player.state = "";
        }
      else
        {

       }
   }

}

//-----------------Use to rotate Navpoints---------------------------------
function setNavBravoON()
{
   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      setNavMarker( $navBravo, true, %playerVeh  );
     }
}
//-----------------------------------------------------------------------------
function init()
{


   $attackStarted = false;

   $Baddies = false;

//***********schedule start in 60 sec*************say something about it

   schedule( "geeweStarted();", 30 );  

$navAlpha = "MissionGroup/NavPoints/navAlpha";
$navBravo = "MissionGroup/NavPoints/navBravo";
$redFlag = "MissionGroup/RedFlag";
}

//-----------------------------------------------------------------------------
function geeweStarted ()
{

   $actionStarted = true;
   say (0,0, "<f5>You are leaving the drop zone. By doing so you will start the mission.");

   $attackStarted = true;

  $Baddies = true;
   createbackup();
//   createbackup();

   setNavBravoON();
   checkFlagArrived();  
   setA();
}

//-----------------------------------------------------------------------------
function checkFlagArrived()
{
    %var = getDistance( $navAlpha, $redFlag );

    if (%var <= 20)
     {
    schedule( "winCondition();", 5 );      
    say(0,0,"<f5> Mission Over","red_flag_cap.wav");
//******************give carrier 100 points*************** 
      $p.flagsCollected = $p.flagsCollected + 1;
     }
    else if (%var > 20)
     {
    schedule("checkFlagArrived();",1);
     }
   
}

//-----------------------------------------------------------------------------
function vehicle::onDestroyed(%this, %who)
{
   // give the death messages...
   %message = getFancyDeathMessage(getHUDName(%this), getHUDName(%who));
   if(%message != "")
   {
      say( 0, 0, %message);
   }

   if(%this == $tm)
    {
     $tm = "";
     pt();
     say(0,0,"red_flag_sur.wav");

      if ((%who != %this) &&
         (getTeam(%who) == getTeam(%this)) &&
         (getTeam(%who) == *IDSTR_TEAM_YELLOW))
          {
//****************carrier killed scoring**********************
         %k=playerManager::vehicleIdToPlayerNum(%who);
         %k.carriersKilled = %k.carriersKilled + 1;

          }

    }






  if ( $actionStarted == true ) checkForPlayersDead();

// see if it is a player
   %player = playerManager::vehicleIdToPlayerNum(%this);
   if(%player == 0) 
   {
    schedule( "deleteObject(" @ %this @ ");", 5 );

// heal and reload the player
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );
   healobject ( %who, 5000 );

  reloadObject(%who, 5000 );
  reloadObject(%who, 5000 );

  checkRedropSquad();

   }

   if ((%this != %who) &&
      (getTeam(%this) == getTeam(%who)) &&
      (getTeam(%this) == *IDSTR_TEAM_YELLOW))
    {
     %killerName = getHudName ( %who );
     %name = getHudName ( %this );


    }

}



//-----------------------------------------------------------------------------
function checkForPlayersDead()
{
//  %allDead = true;

//   %playerCount = playerManager::getPlayerCount();

//   for (%p = 0; %p < %playerCount; %p++)
//     {
//      %player = playerManager::getPlayerNum( %p );

//      %playerVeh = playerManager::playerNumToVehicleId( %player);

//      if (( %playerVeh != "" ) &&
//          (isGroupDestroyed (%playerVeh) == false))
//       {

//         %allDead = false;
//       }
//     }

//  if ( %allDead == true ) schedule ("missionFailed();", 3);

}

//-----------------------------------------------------------------------------
function winCondition()
{
  flushConsoleScheduler();

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($killPoints);
  deleteVariables($deathPoints);
  deleteVariables($flagValue);
  deleteVariables($carrierValue);
  deleteVariables($OVconvoyTech);
  deleteVariables($maxRange);
  deleteVariables($minRange);
  deleteVariables($numLivePlayers);
  deleteVariables($Baddies);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($redFlag);
  deleteVariables($p);
  deleteVariables($tm);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setNavBravoON");
   deleteFunctions("init");
   deleteFunctions("geeweStarted");
   deleteFunctions("checkFlagArrived");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("vehicle::onMessage");
   deleteFunctions("placeObject");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("redFlag::structure::onScan");
   deleteFunctions("mt");
   deleteFunctions("pt");
   deleteFunctions("setA");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

  missionendconditionmet();
}

//-----------------------------------------------------------------------------
function missionFailed()
{
  

  flushConsoleScheduler();
  messageBox(0, "Mission Failed" );

  deleteObject("MissionGroup");
  deleteObject("MissionCleanup");
  deleteVariables($killPoints);
  deleteVariables($deathPoints);
  deleteVariables($flagValue);
  deleteVariables($carrierValue);
  deleteVariables($OVconvoyTech);
  deleteVariables($maxRange);
  deleteVariables($minRange);
  deleteVariables($numLivePlayers);
  deleteVariables($Baddies);
  deleteVariables($navAlpha);
  deleteVariables($navBravo);
  deleteVariables($redFlag);
  deleteVariables($p);
  deleteVariables($tm);
  deleteVariables($Vtec[1]);
  deleteVariables($Vtec[2]);
  deleteVariables($Vtec[3]);
  deleteVariables($Vtec[4]);
  deleteVariables($Vtec[5]);
  deleteVariables($Vtec[6]);
  deleteVariables($Vtec[7]);
  deleteVariables($Vtec[8]);
  deleteVariables($Vtec[9]);
  deleteVariables($Vtec[10]);
  deleteVariables($Vtec[11]);
  deleteVariables($Vtec[12]);
  deleteVariables($Vtec[13]);
  deleteVariables($Vtec[14]);
  deleteVariables($Vtec[15]);
  deleteVariables($Vtec[16]);
  deleteVariables($Vtec[17]);
  deleteVariables($Vtec[18]);
  deleteVariables($Vtec[19]);
  deleteVariables($Vtec[20]);
  deleteVariables($Vtec[21]);
  deleteVariables($Vtec[22]);
  deleteVariables($Vtec[23]);
  deleteVariables($Vtec[24]);
  deleteVariables($Vtec[25]);
  deleteVariables($Vtec[26]);
  deleteVariables($Vtec[27]);
  deleteVariables($Vtec[28]);
  deleteVariables($Vtec[29]);
  deleteVariables($Vtec[30]);
  deleteVariables($Vtec[31]);
  deleteVariables($Vtec[32]);
  deleteVariables($Vtec[33]);
  deleteVariables($Vtec[34]);
  deleteVariables($Vtec[35]);
  deleteVariables($Vtec[36]);
  deleteVariables($Vtec[37]);
  deleteVariables($Vtec[38]);
  deleteVariables($Vtec[39]);
  deleteVariables($Vtec[40]);
  deleteVariables($Vtec[41]);
  deleteVariables($Vtec[42]);
  deleteVariables($Vtec[43]);
  deleteVariables($Vtec[44]);
  deleteVariables($Vtec[45]);
  deleteVariables($Vtec[46]);
  deleteVariables($Vtec[47]);
  deleteVariables($Vtec[48]);
  deleteVariables($Vtec[49]);
  deleteVariables($Vtec[50]);
  deleteVariables($Vtec[51]);
  deleteVariables($Vtec[52]);
  deleteVariables($Vtec[53]);
  deleteVariables($Vtec[54]);
  deleteVariables($Vtec[55]);
  deleteVariables($Vtec[56]);
  deleteVariables($Vn);
  deleteVariables($Vtyp[1]);
  deleteVariables($Vtyp[2]);
  deleteVariables($Vtyp[3]);
  deleteVariables($Vtyp[4]);
  deleteVariables($Vtyp[5]);
  deleteVariables($Vtyp[6]);
  deleteVariables($Vtyp[7]);
  deleteVariables($Vtyp[8]);
  deleteVariables($Vtyp[9]);
  deleteVariables($Vtyp[10]);
  deleteVariables($Vtyp[11]);
  deleteVariables($Vtyp[12]);
  deleteVariables($Vtyp[13]);
  deleteVariables($Vtyp[14]);
  deleteVariables($Vtyp[15]);
  deleteVariables($Vtyp[16]);
  deleteVariables($Vtyp[17]);
  deleteVariables($Vtyp[18]);
  deleteVariables($Vtyp[19]);
  deleteVariables($Vtyp[20]);
  deleteVariables($Vtyp[21]);
  deleteVariables($Vtyp[22]);
  deleteVariables($Vtyp[23]);
  deleteVariables($Vtyp[24]);
  deleteVariables($Vtyp[25]);
  deleteVariables($Vtyp[26]);
  deleteVariables($Vtyp[27]);
  deleteVariables($Vtyp[28]);
  deleteVariables($Vtyp[29]);
  deleteVariables($Vtyp[30]);
  deleteVariables($Vtyp[31]);
  deleteVariables($Vtyp[32]);
  deleteVariables($Vtyp[33]);
  deleteVariables($Vtyp[34]);
  deleteVariables($Vtyp[35]);
  deleteVariables($Vtyp[36]);
  deleteVariables($Vtyp[37]);
  deleteVariables($Vtyp[38]);
  deleteVariables($Vtyp[39]);
  deleteVariables($Vtyp[40]);
  deleteVariables($Vtyp[41]);
  deleteVariables($Vtyp[42]);
  deleteVariables($Vtyp[43]);
  deleteVariables($Vtyp[44]);
  deleteVariables($Vtyp[45]);
  deleteVariables($Vtyp[46]);
  deleteVariables($Vtyp[47]);
  deleteVariables($Vtyp[48]);
  deleteVariables($Vtyp[49]);
  deleteVariables($Vtyp[50]);
  deleteVariables($Vtyp[51]);
  deleteVariables($Vtyp[52]);
  deleteVariables($Vtyp[53]);
  deleteVariables($Vtyp[54]);
  deleteVariables($Vtyp[55]);
  deleteVariables($Vtyp[56]);

   deleteFunctions("onMissionStart");
   deleteFunctions("onMissionLoad");
   deleteFunctions("player::onAdd");
   deleteFunctions("vehicle::onAdd");
   deleteFunctions("setNavBravoON");
   deleteFunctions("init");
   deleteFunctions("geeweStarted");
   deleteFunctions("checkFlagArrived");
   deleteFunctions("vehicle::onDestroyed");
   deleteFunctions("checkForPlayersDead");
   deleteFunctions("winCondition");
   deleteFunctions("missionFailed");
   deleteFunctions("MPcheckBoundary");
   deleteFunctions("pickPlayer");
   deleteFunctions("vehicle::onMessage");
   deleteFunctions("placeObject");
   deleteFunctions("VehicleTech");
   deleteFunctions("getRandomAI");
   deleteFunctions("createbackup");
   deleteFunctions("createSquadTwo");
   deleteFunctions("createSquadThree");
   deleteFunctions("createSquadFour");
   deleteFunctions("createSquadFive");
   deleteFunctions("createSquadSix");
   deleteFunctions("createSquadSeven");
   deleteFunctions("createSquadEight");
   deleteFunctions("dropSquad");
   deleteFunctions("countLivePlayers");
   deleteFunctions("checkRedropSquad");
   deleteFunctions("abs");
   deleteFunctions("findSquadDropPoint");
   deleteFunctions("redFlag::structure::onScan");
   deleteFunctions("mt");
   deleteFunctions("pt");
   deleteFunctions("setA");
   deleteFunctions("*::vehicle::*");
   deleteFunctions("vehicle::*");
   deleteFunctions("*::structure::*");
   deleteFunctions("structure::*");
   deleteFunctions("*::turret::*");
   deleteFunctions("turret::*");
   deleteFunctions("*::trigger::*");
   deleteFunctions("trigger::*");

   missionendconditionmet();
}

//-----------------------------------------------------------------------------
function MPcheckBoundary( %dir, %obj2, %distance, %callback, %time )
{
// This is a modification of the campaign function "CheckBoundary"
//
// %dir  - enter or leave
// %obj2 - any object you want the players distance compared to
//         must be an ID (use getObjectid) and not a string ("MissionGroup/RedHerc/h1")
// %distance - if entering, they'd be within this range to run the function
//             if leaving, they'd be outside this range to run the function
// %callback - name of the function to run
// %time - when to reschedule the next check

  %jobRun = false;

   %playerCount = playerManager::getPlayerCount();

   for(%i=0; %i < %playerCount ; %i++)
     {
     %player = playerManager::getPlayerNum( %i );

     %obj1= playerManager::playerNumToVehicleId( %player);

   %var = getDistance( %obj1, %obj2 );

    if (%var != "0")
     {
     if( %dir == "enter" || %dir == "Enter" )
       {
        if( %var <= %distance )
          {
          if ( %jobRun == false )
            {
              %func = %callback @ "(" @ %obj1 @ ");";
              schedule( %func, 0 );
              %jobRun = true;
            }
          }
       }
    else if( %dir == "leave" || %dir == "Leave" )
      {
       if( %var >= %distance )
         {
          if ( %jobRun == false )
            {
              %func = %callback @ "();";
              schedule( %func, 0 );
              %jobRun = true;
            }
         }
      }
    }
  } // end for loop

  if  (%jobRun != true )
   {
   schedule( "MPcheckBoundary( "
             @ %dir @ ", "
             @ %obj2 @ ", "
             @ %distance @ ", "
             @ %callback @ ", "
             @ %time @ ");",
             %time );

   }

}
//-----------------------------------------------------------------------------
function pickPlayer ()
{

// 100 so we can be assured of getting a live player
   for (%p = 0; %p < 100; %p++)
     {
      %player = playerManager::getPlayerNum( randomInt( 0, playerManager::getPlayerCount() - 1 ) );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         return %playerVeh;
       }
     }
  return 0;

}

//-----------------------------------------------------------------------------
function vehicle::onMessage (%this, %message, %_1, %_2, %_3, %_4, %_5, %_6, %_7, %_8, %_9)
{

// have the enemy pick a new target
// attacker can run into buildings
  %who1 = playerManager::vehicleIdToPlayerNum (%this);
  if ( %who1 != 0 ) return;

   %target = pickPlayer ();

   order (%this, attack, %target);
}

//-----------------------------------------------------------------------------
function placeObject (%object, %x, %y, %rot)
{

  if ( %rot == "" ) %rot = 0;

  %z = getTerrainHeight(%x, %y);
  setPosition (%object, %x, %y, %z + 40, %rot);

}

//--------Boy oh Boy, Wowie, All this stuff is really, really too Cool---------
//-----------------------------------------------------------------------------
// Immutable vehicle attributes
//   tec: 0 = not applicable, 1 = Cybrid, 2 = Human
//   typ: 0 = not applicable, 1 = Herc, 2 = Tank, 3 = Drone, 4 = Flyer
// * denotes non-standard vehicles ordinarily prohibited to human players
// NA denotes ids for which no vehicle exists
$Vtec[1]=2;$Vtyp[1]=1;//TerranApocalypse
$Vtec[2]=2;$Vtyp[2]=1;//TerranMinotaur
$Vtec[3]=2;$Vtyp[3]=1;//TerranGorgon
$Vtec[4]=2;$Vtyp[4]=1;//TerranTalon
$Vtec[5]=2;$Vtyp[5]=1;//TerranBasilisk
$Vtec[6]=2;$Vtyp[6]=2;//Paladin
$Vtec[7]=2;$Vtyp[7]=2;//Myrmidon
$Vtec[8]=2;$Vtyp[8]=2;//Disrupter
$Vtec[9]=0;$Vtyp[9]=4;// * Banshee
$Vtec[10]=2;$Vtyp[10]=1;//Knight'sApocalypse
$Vtec[11]=2;$Vtyp[11]=1;//Knight'sMinotaur
$Vtec[12]=2;$Vtyp[12]=1;//Knight'sGorgon
$Vtec[13]=2;$Vtyp[13]=1;//Knight'sTalon
$Vtec[14]=2;$Vtyp[14]=1;//Knight'sBasilisk
$Vtec[15]=2;$Vtyp[15]=2;//KnightPaladin
$Vtec[16]=2;$Vtyp[16]=2;//KnightMyrmidon
$Vtec[17]=2;$Vtyp[17]=2;//KnightDisrupter
$Vtec[18]=0;$Vtyp[18]=4;// * TerranCargo
$Vtec[19]=0;$Vtyp[19]=4;// * TerranEscape
$Vtec[20]=1;$Vtyp[20]=1;//Seeker
$Vtec[21]=1;$Vtyp[21]=1;//Goad
$Vtec[22]=1;$Vtyp[22]=1;//Shepherd
$Vtec[23]=1;$Vtyp[23]=1;//Adjudicator
$Vtec[24]=1;$Vtyp[24]=1;//Executioner
$Vtec[25]=1;$Vtyp[25]=2;//Bolo
$Vtec[26]=1;$Vtyp[26]=2;//Recluse
$Vtec[27]=1;$Vtyp[27]=1;// * PlatAdjucator
$Vtec[28]=1;$Vtyp[28]=1;// * PlatExecutor
$Vtec[29]=1;$Vtyp[29]=1;// * Prometheus
$Vtec[30]=2;$Vtyp[30]=1;//Emancipator
$Vtec[31]=2;$Vtyp[31]=2;//Avenger
$Vtec[32]=2;$Vtyp[32]=2;//Dreadlock
$Vtec[33]=2;$Vtyp[33]=1;//Olympian
$Vtec[34]=0;$Vtyp[34]=0;// NA
$Vtec[35]=1;$Vtyp[35]=1;//MetagenSeeker
$Vtec[36]=1;$Vtyp[36]=1;//MetagenGoad
$Vtec[37]=1;$Vtyp[37]=1;//MetagenShepherd
$Vtec[38]=1;$Vtyp[38]=1;// * MetagenAdjucator
$Vtec[39]=1;$Vtyp[39]=1;// * MetagenExecutor
$Vtec[40]=2;$Vtyp[40]=1;// * Harabec'sApocalypse
$Vtec[41]=2;$Vtyp[41]=2;//Predator
$Vtec[42]=2;$Vtyp[42]=1;// * Caanon's Basilisk?
$Vtec[43]=2;$Vtyp[43]=1;// * Cinematic Apocalypse
$Vtec[44]=2;$Vtyp[44]=1;// * Cinematic Basilisk
$Vtec[45]=2;$Vtyp[45]=2;// * Super Predator
$Vtec[46]=0;$Vtyp[46]=0;// NA
$Vtec[47]=0;$Vtyp[47]=0;// NA
$Vtec[48]=0;$Vtyp[48]=0;// NA
$Vtec[49]=0;$Vtyp[49]=0;// NA
$Vtec[50]=2;$Vtyp[50]=1;// * PirateApocalypse
$Vtec[51]=2;$Vtyp[51]=2;// * PirateDreadlock
$Vtec[52]=2;$Vtyp[52]=1;//PirateEmancipator
$Vtec[53]=0;$Vtyp[53]=0;// NA
$Vtec[54]=0;$Vtyp[54]=0;// NA
$Vtec[55]=1;$Vtyp[55]=1;//PlayerPlatAdjudicator
$Vtec[56]=1;$Vtyp[56]=1;//PlayerPlatExecutioner
$Vn = 57;
//-----------------------------------------------------------------------------
function VehicleTech(%v)
{
	if ((%v >= 1) && (%v < $Vn)) %t = $Vtec[%v];
	else if ((%v >= 60) && (%v <= 73)) %t = 0;
	else if (%v == 90) %t = 1;
	else if ((%v >= 91) && (%v <= 93)) %t = 0;
	else if ((%v >= 94) && (%v <= 96)) %t = 0;
	else if ((%v >= 110) && (%v <= 111)) %t = 0;
	else if ((%v >= 130) && (%v <= 132)) %t = 0;
	else if ((%v >= 133) && (%v <= 134)) %t = 2;
	else if ((%v >= 135) && (%v <= 136)) %t = 0;
	else if ((%v >= 137) && (%v <= 138)) %t = 2;
	else if (%v == 150) %t = 2;
	else %t = 0;

    return %t;

//	if (%t == 1) return "C";
//	if (%t == 2) return "H";
	return "?";
}

//-----------------------------------------------------------------------------
// this function uses less AI, all standard
function getRandomAI( %vehicleTech )
{

  %vehTech = -1;
%cntr = 0;

  while (( %vehTech != %vehicleTech ) ||
         ( %vehicleTech == 3 ))
   {
// check for valid ranges
     %i = RandomInt(1,28);
     if ( %i>8 && %i<10 )
        %i = RandomInt(1,8);
     if ( %i>17 && %i<20 )
        %i = RandomInt(20,28);

// get appropriate type Tank or Herc
     %type = Herc;
     if ( %i>5  && %i<= 8 )   %type = Tank;
     if ( %i>14 && %i<= 17 )  %type = Tank;
     if ( %i>24 && %i<= 26 )  %type = Tank;

     %vehTech = VehicleTech(%i);

%cntr++;

if ( %cntr > 10) break;
  }

   return NewObject( "AI" @ %i, %type, %i );
}

//-----------------------------------------------------------------------------
function createbackup()
{
   if ( $Baddies == true )
     {

 $numLivePlayers = countLivePlayers ();

     if ( $numLivePlayers >= 1 )  findSquadDropPoint ( getObjectid ($navBravo), 3, "squad1" );
     if ( $numLivePlayers >= 2 )  schedule ("createSquadTwo();", 5 );
     if ( $numLivePlayers >= 3 )  schedule ("createSquadThree();", 7 );
     if ( $numLivePlayers >= 4 )  schedule ("createSquadFour();", 9 );
     if ( $numLivePlayers >= 5 )  schedule ("createSquadFive();", 11 );
//     if ( $numLivePlayers >= 6 )  schedule ("createSquadSix();", 13 );
//     if ( $numLivePlayers >= 7 )  schedule ("createSquadSeven();", 15 );
//     if ( $numLivePlayers >= 8 )  schedule ("createSquadEight();", 17 );

     }
}

function createSquadTwo ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad2" );
}

function createSquadThree()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad3" );
}

function createSquadFour ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad4" );
}

function createSquadFive ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad5" );
}

function createSquadSix ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad6" );
}

function createSquadSeven ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad7" );
}

function createSquadEight ()
{
  findSquadDropPoint ( getObjectid ($navBravo), 1, "squad8" );
}

//-----------------------------------------------------------------------------
function dropSquad(%x, %y, %howMany, %newGroup )
{

   if ( $Baddies == true )
 {



 if ( %howMany > 10 ) %howMany = 10;

  %thisGroup = "MissionGroup/" @ %newgroup;

  newObject( %newGroup, SimGroup );
  addToSet( "MissionGroup", %newGroup );

  for ( %i=0; %i < %howMany; %i++ )
    {
      %herc = getRandomAI( $OVconvoyTech );

      setTeam (%herc, *IDSTR_TEAM_RED);
      setpilotID ( %herc, 29);

      placeObject ( %herc, %x, %y, 0);

  addToSet(  %thisGroup, %herc );

      %x = %x + 50 ;
      %y = %y + 50 ;

      if ( %i == 0 )
       {
         %leadHerc = %herc;
       }


      order (%herc, speed, high);


          %targetPlayer = pickPlayer();
          order ( %herc, attack, %targetPlayer );

    }

 }
}
//-----------------------------------------------------------------------------
function countLivePlayers ()
{

  %count = 0;

   %playerCount = playerManager::getPlayerCount();

   for (%p = 0; %p < %playerCount; %p++)
     {
      %player = playerManager::getPlayerNum( %p );

      %playerVeh = playerManager::playerNumToVehicleId( %player);

      if (( %playerVeh != "" ) &&
          (isGroupDestroyed (%playerVeh) == false))
       {
         %count++;
       }
     }
  return %count;

}
//-----------------------------------------------------------------------------
function checkRedropSquad()
{
 %howMany = countLivePlayers ();

     if (( %howMany >= 1 ) &&
         ( isGroupDestroyed ("MissionGroup/squad1") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad1" );
       }

     if (( %howMany >= 2 ) &&
         ( isGroupDestroyed ("MissionGroup/squad2") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad2" );
       }

     if (( %howMany >= 3 ) &&
         ( isGroupDestroyed ("MissionGroup/squad3") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad3" );
       }

     if (( %howMany >= 4 ) &&
         ( isGroupDestroyed ("MissionGroup/squad4") == true ))
       {
         %center = pickPlayer();
         findSquadDropPoint ( %center, 2, "squad4" );
       }
}

//-----------------------------------------------------------------------------
function abs(%n)
{
  if ( %n < 0 ) 
    {
      %n = %n * -1;
      return %n;
    }
   else
    {
      return %n;
    }
}

//-----------------------------------------------------------------------------
function findSquadDropPoint ( %centerObject, %howMany, %squadName )
{

%cntr = 0;

     %maxRange = $maxRange;
     %minRange = $minRange;

// not really a target, but the center of attention
   %target = %centerObject;

   %OVbaseX = getPosition (%target, x);
   %OVbaseY = getPosition (%target, y);

// select a drop zone
  %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
  %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

  %deltaX = %OVbaseX - %xDrop;
  %deltaY = %OVbaseY - %yDrop;

  %deltaX = abs ( %deltaX );
  %deltaY = abs ( %deltaY );

  %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );

  if  (( %dropDistance < %minRange ) ||
       ( %dropDistance > %maxRange ))
   {
     %dropDistance = randomInt ( %minRange, %maxRange );

// keep X position, for no particluar reason
      %temp = (( %xDrop * %xDrop ) - ( %dropDistance * %dropDistance ));
      %temp = abs ( %temp );
      %yDrop = sqrt ( %temp );

   while (1)
   {

// select a drop zone
     %xDrop = RandomInt ( %OVbaseX-%maxRange, %OVbaseX+%maxRange );
     %yDrop = RandomInt ( %OVbaseY-%maxRange, %OVbaseY+%maxRange );

     %deltaX = %OVbaseX - %xDrop;
     %deltaY = %OVbaseY - %yDrop;

     %deltaX = abs ( %deltaX );
     %deltaY = abs ( %deltaY );

     %dropDistance = sqrt ( (%deltaX*%deltaX) + (%deltaY*%deltaY) );


  if  (( %dropDistance > %minRange ) &&
       ( %dropDistance < %maxRange ))    break;

%cntr++;
 if ( %cntr > 20 ) break;

   }

   }

   dropSquad (%xDrop, %yDrop, %howMany, %squadName);

}

//-------------------------------------------------------------
//---------------TRACTOR BEAM STUFF FROM "MOVE IT"---------------
//------------------Thank you, mike the goad---------------------
// ok, scanner2 can steal it from scanner1, why use trigger??, why not scan??
// then have nav bravo follow and red glow do the same.  When it arrives use check
// boundary function and assign points to $tm who is the carrier.  This way if the
// player leaves or dies, the moving group stays where it is.
 
function redFlag::structure::onScan(%this,%scanner)	
{
if($tm == "")
 {
 $tm = %scanner;					//new global 
//*************scoring works with flags collected************
 $p=playerManager::vehicleIdToPlayerNum(%scanner);
 say($p,0,"<f5>Get Battle Flag to Alpha.  Scan again to drop Flag.");
 %p1 = getHUDName($tm);
//add flag stolen
 say(0,0,"<f5> "@%p1@" Has the Battle Flag.  Kill him !!!!!","red_flag_stol.wav");
 setvehicleSpecialIdentity($tm,true,Red);
 setNavMarker( $navAlpha, true, $tm  );

mt();
 } 
 else
 {
 $tm = "";
 }
}

function mt()
{
%x = getPosition($tm,x);
%y = getPosition($tm,y);
%z = getPosition($tm,z);
if(%x == %z)					// he died or left
 {
 $tm = "";
 pt();
 }
 else
 {
   %z2 = %z + 10.0;
   setPosition ($navBravo , %x, %y, %z);
   setPosition ($redFlag , %x, %y, %z2);

 }
if($tm != "")
 {
 schedule("mt();",0.1);
 }
 else
 {
 pt();
 }
}

function pt()
{
%x = getPosition($redFlag,x);
%y = getPosition($redFlag,y);
%z = getTerrainHeight(%x,%y);
setPosition ($navBravo , %x, %y, %z);
setPosition ($redFlag , %x, %y, %z);
setvehicleSpecialIdentity($tm,false);
}

//-------------------------------------------------------------------------------
function getPlayerCarriersKilled(%a)
{
   %killed = %a.carriersKilled;
   if (%killed == "") {
      return 0;
   }
   else {
      return %killed;
   }
}
//-------------------------------------------------------------------------------
function getPlayerFlags(%a)
{
   %flags = %a.flagsCollected;
   if (%flags == "") {
      return 0;
   }
   else {
      return %flags;
   }
}   
//------------------------------------------------------------------------------
// scoreboard 

function getPlayerScore(%a)
{
   return((getPlayerFlags(%a) * $flagValue) + 
          (getPlayerCarriersKilled(%a) * $carrierValue) +
          (getKills(%a) * $killPoints) - 
          (getDeaths(%a) * $deathPoints));
}


//-------------------------------------------------------------------------------
function initScoreBoard()
{
   deleteVariables("$ScoreBoard::PlayerColumn*");
   deleteVariables("$ScoreBoard::TeamColumn*");


       // Player ScoreBoard column headings
	   
	   $ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SCORE;
	   $ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_KILLS;
	   $ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_DEATHS;

	   // Player ScoreBoard column functions
	   
	   $ScoreBoard::PlayerColumnFunction1 = "getPlayerScore";
	   $ScoreBoard::PlayerColumnFunction2 = "getKills";
	   $ScoreBoard::PlayerColumnFunction3 = "getDeaths";



   // tell server to process all the scoreboard definitions defined above
   serverInitScoreBoard();
}
//------------------------------------------------------------------------------
function setA()
{
    %location = randomInt(1,4);

    if (%location == 1)
    {
    setPosition($navAlpha, 2627.68, -3395.15, 257.69); 
    }
    if (%location == 2)
    {
    setPosition($navAlpha, -1717.06, 2829.91, 349.11); 
    }
    if (%location == 3)
    {
    setPosition($navAlpha, -3222.61, -1526.59, 338.37); 
    }
    if (%location == 4)
    {
    setPosition($navAlpha, 2971.72, 2188.48, 289.67); 
    }


   schedule( "setA();", 420 );  

}

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
























































































































