$missionName = "Cold Titan Night";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");
exec("BoPstdlib.cs");

function mapOnMissionStart() { 
  $healRate	= 100;   
  $ammoRate 	= 3;
  $padWaitTime	= 45;
  $zenWaitTime	= 90;
  titanSounds();	
}

function ZenHeal::trigger::onEnter(%this, %object) {
  Zen::onEnter(%this, %object, *IDMULT_CHAT_HEALPAD, true, true);  
}

function ZenHeal::trigger::onContact(%this, %object) {
  Zen::work(%this, %object, $healRate, 0, $padWaitTime, true); 
}

function ZenAmmo::trigger::onEnter(%this, %object) {
  Zen::onEnter(%this, %object, *IDMULT_CHAT_AMMOPAD, true, true);  
}

function ZenAmmo::trigger::onContact(%this, %object) {
  Zen::work(%this, %object, 0, $ammoRate, $padWaitTime, true); 
}

function ZenAll::trigger::onEnter(%this, %object) {
  Zen::onEnter(%this, %object, *IDMULT_CHAT_ALLPAD, true, true);  
}

function ZenAll::trigger::onContact(%this, %object) {
  Zen::work(%this, %object, $healRate, $ammoRate, $padWaitTime, true); 
}

function tur1::turret::onAdd(%this) {
  $turret1=%this;
  order($turret1,ShutDown,true);
}

function tur2::turret::onAdd(%this) {
  $turret2=%this;
  order($turret2,ShutDown,true);
}

function Frosty::structure::onAttacked(%attacked,%attacker) {
  %bang1=getObjectId("MissionGroup\\extra\\frosty's house\\house1");
  healObject(%bang1,-30000);
  order($turret1,ShutDown,false);
  order($turret1, Attack, %attacker);
  %bang2=getObjectId("MissionGroup\\extra\\frosty's house\\house2");
  healObject(%bang2,-30000);
  order($turret2,ShutDown,false);
  order($turret2, Attack, %attacker);
}
