// FILENAME:	Little_Fort.cs
//
// AUTHOR:  	Mace Griffen
//------------------------------------------------------------------------------

$missionName = "Little_Fort";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function onMissionStart()
{
      $killPoints = 3;
      $deathPoints = 2;
      $healRate = 100;   
	$ammoRate = 3;
   	$padWaitTime = 45;
  	$zenWaitTime = 90;

	titanSounds();	
}

function player::onAdd(%this)
{
   say(%this, 0, "wellcome troop to Little_Fort! this map is small and funny map i made <F2>:)<F2> im still working on a web site to put my downloads on it :)!.");
}

function vehicle::onAdd(%vehicleId)
{
   %vehicleId.name = getHUDName(%vehicleId);
}

function onMissionLoad()
{
   cdAudioCycle("Yougot", "Newtech", "Mechsoul"); 
}

function fence::trigger::OnEnter(%this, %object)
{
      healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
	healObject(%object, -10000);
      say("everybody", 0, %object.name @ " was shocked to death by the electric fence!","sfx_electrical_bzzt.WAV");
}