// FILENAME:	[PS]Mines.cs				  
//
// AUTHORS:  	[:: Duo ::]
//------------------------------------------------------------------------------

$missionName = "[PS]Mines";

function setDefaultMissionOptions()
{
	echo("function setDefaultMissionOptions()");

   $server::AllowTeamRed      = true;
   $server::AllowTeamBlue     = true;
   $server::AllowTeamYellow   = false;
   $server::AllowTeamPurple   = false;

   $server::TeamPlay          = true;
   $server::AllowDeathmatch   = false;
   $server::AllowTeamPlay     = true;	

   $server::disableTeamRed    = false;
   $server::disableTeamBlue   = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to the UNMC Mines. Please feel free to enter the mines as your wish. Just take the elevator down and your in!");
}	

function onMissionLoad()
{
	echo("function onMissionLoad()");

   cdAudioCycle("Yougot", "Terror", "Cloudburst", "Mechsoul"); 
}

function up::structure::onScan(%scanned, %scanner)
{
   setPosition(%scanner, -8489, 918.516, 771.314);
}

function mine::trigger::onEnter(%trigger, %vehicleId)

{
   
setPosition(%vehicleId, -8523.11, -608.113, 103.384);

}



function back::structure::onScan(%scanned, %scanner)
{
setPosition(%scanner, 290.281, -644.356, 100);
}

function meeting::structure::onScan(%scanned, %scanner)
{
setPosition(%scanner, 952.944, -1669.52, 993.806);
}

function dm::trigger::onEnter(%this, %vehicleId)
{
setPosition(%vehicleId, -8486.28, 914.496, -2.71347);
}
