// FILENAME:	UNMC-SpacePort.cs				  
//
// AUTHORS:  	(=*=) Rad Wolf
//
//------------------------------------------------------------------------------

$missionName = "UNMC SpacePort";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

   // what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

   // what can the server admin choose for available teams
   $server::disableTeamRed = false;
   $server::disableTeamBlue = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}

//--------------------------------------------------------------------------------

	
function setDefaultMissionOptions()
{
	echo("function setDefaultMissionOptions()");

   $server::AllowTeamRed      = true;
   $server::AllowTeamBlue     = true;
   $server::AllowTeamYellow   = false;
   $server::AllowTeamPurple   = false;

   $server::TeamPlay          = false;
   $server::AllowDeathmatch   = true;
   $server::AllowTeamPlay     = false;	

   $server::disableTeamRed    = false;
   $server::disableTeamBlue   = false;
   $server::disableTeamYellow = true;
   $server::disableTeamPurple = true;
}
	

function onMissionLoad()
{
	echo("function onMissionLoad()");

   cdAudioCycle("Yougot", "Terror", "Cloudburst", "Mechsoul"); 
}

function player::onAdd(%this)
{
   say(%this, 0, "Welcome to the UNMC SpacePort. It is currently under construction at this time, and many repairs are being done to the ships. Please refer to the UNMC page (http://www.unmc-ss.cjb.net) for details and updates about this map. Thanks! (=*=) Rad Wolf");
   messageBox(%this, "Visit UNMC at http://www.unmc-ss.cjb.net!");
}

function S1::trigger::onEnter(%this, %vehicleId)
{
   healObject(%vehicleId, -50000);
   say(0,0,""@getHudName(%vehicleId)@" tried to enter the "UNMC Only" room but failed to do so.");
}