// FILENAME:	TDM_Moon_Shaft.cs
//
// AUTHORS:  	Equuleus
//------------------------------------------------------------------------------

$missionName = "TDM_Moon_Bunkers";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionStart()
{
	
   
	cdAudioCycle("Watching", "Terror", "Mechsoul"); 
        
}

function onMissionLoad(){
   cdAudioCycle("Watching", "Terror", "Mechsoul"); 
}
   // move the map
   $server::HudMapViewOffsetX = 1700;
   $server::HudMapViewOffsetY = -6937;


// Transporters
//------------------------------------------------------------------------------

function zenTransporter1::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 2251, -6553, 248);
}

function zenTransporter2::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 2513, -6379, 369);
}

function zenTransporter3::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1329, -7203, 232);
}

function zenTransporter4::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1061, -7388, 355);
}

function zenTransporter5::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1924, -6778, 347);
}

function zenTransporter6::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1648, -6954, 347);
}

function zenTransporter7::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 2115, -6641, 256);
}

function zenTransporter8::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1442, -7104, 230);
}

function zenTransporter9::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 1139, -7326, 238);
}

function zenTransporter10::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, 2441, -6437, 254);
}
