// FILENAME:	TDM_Sanctuary.cs
//
// AUTHORS:  	Equuleus
//------------------------------------------------------------------------------

$missionName = "TDM_Sanctuary";

exec("multiplayerStdLib.cs");
exec("DMstdLib.cs");

function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	
	
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = true;
	$server::AllowTeamPurple = true;
}

function onMissionLoad(){
   cdAudioCycle("Yougot", "SS3", "SS1"); 
}

// move the map
$server::HudMapViewOffsetX = -5248;
$server::HudMapViewOffsetY = 5285;

function onMissionStart()
{
	titanSounds();
        
        
}



// Transporters
//---------------------------------------------------------------------------------------------------------------------------
function zenTransporter::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, -5240, 5275, 35);
}

function zenTransporter1::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, -5866, 5227, 82);
}

function zenTransporter2::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, -4625, 5257, 82);
}

function zenTransporter3::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, -5240, 5275, 35);
}

function zenTransporter4::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, -5866, 5227, 82);
}

function zenTransporter5::trigger::onContact(%trigger, %vehicleId)
{
	
	setPosition(%vehicleId, -4625, 5257, 82);
}